library(stockassessment)
load("run/model.RData")
FC<-list()
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178,.164, .164), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,NA,NA), label="MSY approach, Fmsy lower*SSB2024/MSY Btrigger", rec.years=2004:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178,.225, .225), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,NA,NA), label="MSY approach, Fp05 as Fmsy upper*SSB2024/MSY Btrigger", rec.years=2004:2022, ave.years = max(fit$data$years) + (0:0), savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178,.225, .225), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,NA,NA), label="Fmsy *SSB2024/MSY Btrigger", rec.years=2004:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178,.225, .225), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,NA,NA), label="Fmsy  *SSB2024/MSY Btrigger short R sampling", rec.years=2019:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178,.26, .26), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,NA,NA), label="Fmsy/Fpa", rec.years=2004:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178, NA, .26), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,580,NA), label="TAC2023*1.2", rec.years=2004:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178 ,NA, NA), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,0,0), label="zero catch", rec.years=2004:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178,.315, .315), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,NA,NA), label="other options, Flim", rec.years=2004:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178,NA,.238), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,NA,NA),nextssb=c(NA,NA, 1850,NA),label="SSB(2025)= Blim", rec.years=2004:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178,0.178, NA), fscale=c(NA,NA,NA,1), catchval=c(302,NA,NA,NA),label="other options, F=F2022", rec.years=2004:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178,NA,.238), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,NA,NA),nextssb=c(NA,NA,2600,NA),label="SSB(2025)= Bpa,Btrigger", rec.years=2004:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178,NA,.238), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,NA,NA),nextssb=c(NA,NA,2250,NA),label="SSB(2025)= SSB(2024)", rec.years=2004:2022, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,.178 ,NA, NA), fscale=c(NA,NA,NA,NA), catchval=c(302,NA,120,0), label="5.0% probability of the spawning stock biomass to fall below Blim in 2025", rec.years=2004:2022, savesim=TRUE)



Blim=1850
above<-function(x){xx<-mean(x[[4]]$ssb>Blim);yr<-x[[4]]$year; round(xx*100,1)}
Pabove<-lapply(FC, above)
names(Pabove)<-lapply(FC, function(x){attr(x,"label")})
Pabove<-as.matrix(unlist(Pabove))
colnames(Pabove)<-paste0("P(SSB",FC[[1]][[4]]$year, " > ",Blim,") in %")


save(FC, Pabove, file="run/forecast.RData")

